/*------------------------------------------------*/
/* 51ncurses/thread-ncurses.c                     */
#include <ncurses.h>
#include <stdbool.h>

typedef struct {
    void (*fce) (void *);
    void *data;
} THNcursesJob;

/**
 * Pridej do fronty job, ktery se provede jednou
 * v thncurses_paint() (a pak se z fronty odebere).
 */
bool thncurses_add_job(THNcursesJob job);
/**
 * Prida okno do seznamu oken, ktere se po spusteni
 * vsech jobu prekresli (v thncurses_paint()).
 * Okna se ze seznamu neodebírají.
 */
bool thncurses_add_window(WINDOW * win);
void thncurses_paint(void);
/**
 * zablokuje vsechny thncurses_* funkce, takze
 * se uz zadne funkce ncurses nebudou volat.
 */
void thncurses_stop(void);

/* obsluha signalu */

/**
 * Funkce, ktera se ma spustit jako samostatny thread.
 * Ceka na uvolneni semaforu funkci thncurses_signal.
 */
void * thncurses_signal_thread(THNcursesJob * tjob);
/**
 * Uvolni semafor, cimz umozni spustit job funkci thncurses_signal_thread.
 * Vola se v obsluze signalu (WINCH)
 */
void thncurses_signal(void);
/*------------------------------------------------*/
